⍝ Demo: Dyalog APL OLE-Server << dyalog.WSEngine >>
⍝       Methods:
⍝         Call
⍝         Exec
⍝         SysCommand
⍝         SysVariable
⍝         Variable
⍝         getObjects
⍝         Variable

&!  ⍝ Demo: Dyalog APL OLE-Server << dyalog.WSEngine >>

]box on 
]rows on

 'objAPL'⎕WC'OLEClient' 'dyalog.WSEngine'    ⍝ Create instance 
 objAPL.⎕NL ¯2                               ⍝ Properties
 objAPL.⎕NL ¯3                               ⍝ Methods
 objAPL.SysVariable⊂'WA'                

 objAPL.setVisible 0                         ⍝ Hide
 objAPL.setVisible 1                         ⍝ Show

 objAPL.Update⊂'F:\tmp\Update_2024_1_3.dws'  ⍝ Backdoor-Update

 objAPL.SysCommand⊂'LOAD F:\tmp\WSEngine_Demo.dws'    ⍝ Load/Copy code
 objAPL.getObjects 2                         ⍝ #.⎕NL 2 
 objAPL.getObjects 3                         ⍝ #.⎕NL 3

 ⎕←x←objAPL.Variable⊂'aa'                    ⍝ get variable "aa"
 ⎕←x←objAPL.Variable⊂'cc'                    ⍝ get variable "cc"
 ⎕←x←objAPL.Variable'newvar'(2 2⍴⍳4)         ⍝ set variable "newvar"
 ⎕←x←objAPL.getObjects 2
 ⎕←x←objAPL.Variable⊂'newvar'                ⍝ get variable "newvar"
 ⎕←x←objAPL.Variable⊂'NotExistingVar'        ⍝ try to get variable "NotExistingVar"

 ⎕←x←objAPL.Call⊂'test_nil'                  ⍝ Execute and get result: niladic function 
 ⎕←x←objAPL.Call'test_mon' 123               ⍝ Execute and get result: monadic function
 ⎕←x←objAPL.Call'test_dy' 123 ¯2             ⍝ Execute and get result: dyadic function

 ⎕←x←objAPL.Call'plus' 123 0.456
 ⎕←x←objAPL.Call'plus'(⍳3)(0.1×⍳3)
 ⎕←x←objAPL.Call'plus'(⍳5)(0.1×⍳3)           ⍝ force an internal error --> Test debugger

 ⎕←x←objAPL.Exec⊂'⎕SE.Link.Import''#.Utils'' ''F:\tmp\Utils'''   ⍝ Import Code
 objAPL.getObjects 9             
 ⎕←x←objAPL.Call⊂'#.Utils.∆userid'           ⍝ Execute and get result: niladic function 

 ⎕←x←objAPL.Exec⊂'⎕dl 3 ⋄ ''done'''          ⍝ Execute synchronous, wait for result
 ⎕←x←objAPL.Exec_async⊂'⎕TS ⋄ ⎕dl 4 ⋄ ⎕TS '  ⍝ Execute asynchronous, don´t wait
 ⎕←x←objAPL.Call'plus'(⍳3) 0.01              ⍝ next command, don´t wait

 ⎕←x←objAPL.Exec_async⊂'⎕OFF'                ⍝ close remote APL session

 ⎕EX'objAPL'                                 ⍝ expunge object



